<?php
/**
 */

namespace execut\files\bootstrap;


use execut\files\Attacher;
use execut\files\Module;
use execut\yii\Bootstrap;

class Common extends Bootstrap
{
    public $moduleId = 'files';

    public function getDefaultDepends()
    {
        return [
            'modules' => [
                $this->moduleId => [
                    'class' => Module::class,
                ],
            ],
        ];
    }

    public function bootstrap($app)
    {
        parent::bootstrap($app); // TODO: Change the autogenerated stub

        $this->attachToModules();
    }

    protected function attachToModules() {
        $models = \yii::$app->getModule($this->moduleId)->getAttachedModels();
        $tables = [];
        if (!empty($models)) {
            foreach ($models as $model) {
                $tables[] = $model::tableName();
            }
        }

        $attacher = new Attacher([
            'tables' => $tables,
            'moduleId' => $this->moduleId,
        ]);

        $attacher->safeUp();
    }
}